unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, UStack, UTree, ExtCtrls;

type
  TMainForm = class(TForm)
    TreeViewMain: TTreeView;
    Label1: TLabel;
    Einput: TEdit;
    Label2: TLabel;
    EInverse: TEdit;
    ButToTree: TButton;
    Label3: TLabel;
    Label4: TLabel;
    EOutput: TEdit;
    ButModify: TButton;
    Panel1: TPanel;
    Splitter1: TSplitter;
    procedure EinputChange(Sender: TObject);
    procedure EinputKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure ButToTreeClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButModifyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

const
  variables: set of Char = ['a' .. 'z', 'A' .. 'Z'];
  signs: set of Char = ['+', '-', '*', '/'];
  digits: set of Char = ['0' .. '9'];

var
  Tree: TTree;
{$R *.dfm}

function getLastSym(var s: string): Char; //   ,   
var
  i: integer;
begin
  i := length(s);
  while (i > 0) and (s[i] = ' ') do
    dec(i);
  if i = 0 then
    result := ' '
  else
    result := s[i];
end;

function ExpIsTrue: boolean; //    
var
  s: string;
  kol, i, len: integer;
begin
  kol := 0;
  s := MainForm.Einput.Text;
  len := length(s);
  i := 1;
  while (kol >= 0) and (i <= len) do //  Kol   ,   
  begin
    if s[i] = '(' then
      inc(kol)
    else if s[i] = ')' then
      dec(kol);
    inc(i);
  end;
  if kol = 0 then
    result := true
  else
    result := false;
end;

procedure TMainForm.EinputChange(Sender: TObject);
var
  s: string;            //     
  ch: Char;              //  
begin
  s := MainForm.Einput.Text;
  ch := getLastSym(s); //       
  if (s <> '') and (not(ch in signs)) and (ch <> ' ') and ExpIsTrue then
    MainForm.ButToTree.Enabled := true
  else
    MainForm.ButToTree.Enabled := false;
end;

procedure TMainForm.EinputKeyPress(Sender: TObject; var Key: Char);
var
  s: string;      //,   ,   
  ch: Char;
begin
  s := MainForm.Einput.Text;
  if Key = ')' then //  
  begin
    if ExpIsTrue then
      Key := #0;
  end
  else if Key = '(' then //  
  begin
    ch := getLastSym(s);
    if (ch in digits) or (ch in variables) then
      Key := #0;
  end
  else if Key in signs then //  
  begin
    ch := getLastSym(s);
    if (ch = '(') or (ch in signs) or (ch = ' ') then
      Key := #0;
  end
  else if Key in variables then //  
  begin
    ch := getLastSym(s);
    if (ch in variables) or (ch in digits) or (ch = ')') then
      Key := #0;
  end
  else if Key in digits then
  begin //  
    ch := getLastSym(s);
    if (ch in variables) or (ch = ')') or (ch in digits) then
      Key := #0;
  end
  else if (Key <> #8) and (Key <> ' ') then
    Key := #0; //       ,    
end;

procedure TMainForm.FormCreate(Sender: TObject);   //  
begin                                      //  
  MainForm.ButToTree.Enabled := false;
  Tree := TTree.Create;
end;

function MakeInverse(var s: string): string; //   
var
  rez: string;
  i, len: integer;
  ch: ^Char;
  st: TStack;        //... 
begin
  st := TStack.Create;     // 
  len := length(s);
  rez := '';
  i := 1;
  while i <= len do //       
  begin
    if (s[i] in variables) or (s[i] in digits) then
      rez := rez + s[i] + ' '
    else //  
      if s[i] = '(' then
      st.push(@s[i])
    else if s[i] = ')' then
    begin
      ch := st.pop;
      while (ch <> nil) and (ch^ <> '(') do
      begin
        rez := rez + ch^ + ' ';
        ch := st.pop;
      end;
    end
    else if s[i] in ['*', '/'] then
    begin
      ch := st.GetLast;
      if (ch <> nil) and (ch^ in ['*', '/']) then
      begin
        rez := rez + ch^ + ' ';
        st.pop;
      end;
      st.push(@s[i]);
    end
    else if s[i] in ['-', '+'] then
    begin
      ch := st.GetLast;
      if (ch <> nil) and (ch^ in ['*', '/']) then
      begin
        rez := rez + ch^ + ' ';
        st.pop;
      end;
      ch := st.GetLast;
      if (ch <> nil) and (ch^ in ['+', '-']) then
      begin
        rez := rez + ch^ + ' ';
        st.pop;
      end;
      st.push(@s[i]);
    end;
    inc(i);
  end;

  //   
  while not st.IsEmpty do
  begin
    ch := st.pop;
    rez := rez + ch^;
  end;

  result := rez;
  st.Destroy;        // 
end;

procedure TMainForm.ButModifyClick(Sender: TObject);  //   
begin
  Tree.ProcessTree;   // 
  MainForm.TreeViewMain.Items.BeginUpdate;
  Tree.MakeForView(MainForm.TreeViewMain.Items);    //   treeView
  MainForm.TreeViewMain.FullExpand;        // 
  MainForm.TreeViewMain.Items.EndUpdate;
  MainForm.EOutput.Text := Tree.MakeToStr;   //     
end;

procedure TMainForm.ButToTreeClick(Sender: TObject);  //     
var
  s, rez: string;
begin
  s := MainForm.Einput.Text;
  rez := MakeInverse(s);
  MainForm.EInverse.Text := rez;    //make inverse expression
  Tree.MakeFromStr(rez);           //and make the tree
  MainForm.TreeViewMain.Items.BeginUpdate;
  Tree.MakeForView(MainForm.TreeViewMain.Items);  //   TreeView
  MainForm.TreeViewMain.FullExpand;        // 
  MainForm.TreeViewMain.Items.EndUpdate;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Tree.Destroy;               //   
end;

end.    //  ! 601      !!!
