unit UStack;

interface

type
  uk = ^zveno;

  zveno = record
    data: pointer;
    next: uk;
  end;

  TStack = class
  private
    Fhead: uk;
    Fcount: integer;
  protected
  public
    constructor Create; // creates empty Stack
    procedure Push(el: pointer); // add element to Stack
    function Pop: pointer; // Get element from Stack
    function GetLast: pointer; // See last element
    function IsEmpty: boolean; // Checks Stack on emptyness
    procedure Clear; // clears Stack

    property Count: integer // quantity of elements in Stack
      read Fcount;
  end;

implementation

procedure TStack.Clear; // clears Stack
begin
  while Fhead <> nil do
    Pop;
end;

constructor TStack.Create; // creates empty Stack
begin
  Fhead := nil;
  Fcount := 0;
end;

function TStack.GetLast: pointer; // See last element
begin
  if Fhead = nil then
    result := nil
  else
    result := Fhead.data;
end;

function TStack.IsEmpty: boolean; // Checks Stack on emptyness
begin
  result := Fhead = nil;
end;

function TStack.Pop: pointer; // Get element from Stack
var
  buf: uk;
begin
  if Fhead = nil then
    result := nil
  else
  begin
    result := Fhead.data;
    buf := Fhead;
    Fhead := Fhead.next;
    dispose(buf);
    dec(Fcount);
  end;
end;

procedure TStack.Push(el: pointer); // add element to Stack
var
  buf: uk;
begin
  new(buf);
  buf.data := el;
  buf.next := Fhead;
  Fhead := buf;
  inc(Fcount);
end;

end.
